/**
 * Sideways for Drupal, adapted from http://manos.malihu.gr/sideways-jquery-fullscreen-image-gallery
 * @2012 Gianluca Cassarino gcassarino at gmail.com
 * 
 * 06lug2012: aggiunta gestione automatica background immagini
 * 06lug2012: added a feature to tune the color of the background with the image above using html5 canvas
 * 
 */


// usa $jq() per noConflict con la versione JQuery di D6

//set default view mode
var defaultViewMode = "full"; //full (fullscreen background), fit (fit to window), original (no scale)
//cache vars
var bg = $jq("#bg");
var bgimg = $jq("#bg #bgimg");
var preloader = $jq("#preloader");
var outer_container = $jq("#outer_container");
var outer_container_a = $jq("#outer_container a.thumb_link");
var toolbar = $jq("#toolbar");
var nextimage_tip = $jq("#nextimage_tip");

// creo un canvas lo usero onClick per determinare dinamicamente lo sfondo dello stesso colore della immagine mostrata
var canvas = $jq('<canvas/>').appendTo('body');    
canvas[0].setAttribute('id','myCanvas');
$jq("#myCanvas").css("display", "none");
var context = canvas[0].getContext("2d");    

//var bgAutoColor = sideways_settings_obj.bgAutoColor;


/* FUNCS */

function LargeImageLoad(el) {
    preloader.fadeOut("fast"); //hide preloader
    el.removeAttr("width").removeAttr("height").css({
        width: "",
        height: ""
    }); //lose all previous dimensions in order to rescale new image data
    bg.data("originalImageWidth", el.width()).data("originalImageHeight", el.height());
    if (bg.data("newTitle")) {
        el.attr("title", bg.data("newTitle")); //set new image title attribute
    }
    FullScreenBackground(el); //scale new image    
    bg.data("nextImage", $jq(outer_container.data("selectedThumb")).next().attr("href")); //get and store next image
    if (typeof itemIndex != "undefined") {
        if (itemIndex == lastItemIndex) { //check if it is the last image
            bg.data("lastImageReached", "Y");
            bg.data("nextImage", outer_container_a.first().attr("href")); //get and store next image
        } else {
            bg.data("lastImageReached", "N");
        }
    } else {
        bg.data("lastImageReached", "N");
    }
    el.fadeIn("slow"); //fadein background image
    if (bg.data("nextImage") || bg.data("lastImageReached") == "Y") { //don't close thumbs pane on 1st load
        SlidePanels("close"); //close the left pane
    }
    NextImageTip();
}

//function to get element index (fuck you IE!)
function getIndex(theItem) {
    for (var i = 0, length = outer_container_a.length; i < length; i++) {
        if (outer_container_a[i] === theItem) {
            return i;
        }
    }
}

//next image balloon tip
function NextImageTip() {    
    if (bg.data("nextImage")) { //check if this is the first image	
        nextimage_tip.stop().css("right", 20).fadeIn("fast").fadeOut(2000, "easeInExpo", function() { // sembra che alla lunga il tasto non venga mostrato piu per un valore di opacity errato
            nextimage_tip.css("right", $jq(window).width());
        });
    }
}

//slide in/out left pane function
function SlidePanels(action) {
    var speed = 900;
    var easing = bg.data("sbEffect"); //var easing = "easeInOutExpo";
        
    if (action == "open") {
        $jq("#arrow_indicator").fadeTo("fast", 0);
        outer_container.stop().animate({
            left: 0
        }, speed, easing);
        bg.stop().animate({
            left: 585
        }, speed, easing);
    } else {
        outer_container.stop().animate({
            left: -710
        }, speed, easing);
        bg.stop().animate({
            left: 0
        }, speed, easing, function() {
            $jq("#arrow_indicator").fadeTo("fast", 1);
        });
    }
}

//Image scale function
function FullScreenBackground(theItem) {
    var winWidth = $jq(window).width();
    var winHeight = $jq(window).height();
    var imageWidth = $jq(theItem).width();
    var imageHeight = $jq(theItem).height();
    if (toolbar.data("imageViewMode") != "original") { //scale
        $jq(theItem).removeClass("with_border").removeClass("with_shadow"); //remove extra styles of orininal view mode
        var picHeight = imageHeight / imageWidth;
        var picWidth = imageWidth / imageHeight;
        if (toolbar.data("imageViewMode") != "fit") { //image view mode: full
            if ((winHeight / winWidth) < picHeight) {
                $jq(theItem).css("width", winWidth).css("height", picHeight * winWidth);
            } else {
                $jq(theItem).css("height", winHeight).css("width", picWidth * winHeight);
            };
        } else { //image view mode: fit
            if ((winHeight / winWidth) > picHeight) {
                $jq(theItem).css("width", winWidth).css("height", picHeight * winWidth);
            } else {
                $jq(theItem).css("height", winHeight).css("width", picWidth * winHeight);
            };
        }
        //center it
        $jq(theItem).css("margin-left", ((winWidth - $jq(theItem).width()) / 2)).css("margin-top", ((winHeight - $jq(theItem).height()) / 2));
    } else { //no scale
        //add extra styles for orininal view mode
        $jq(theItem).addClass("with_border").addClass("with_shadow");
        //set original dimensions
        $jq(theItem).css("width", bg.data("originalImageWidth")).css("height", bg.data("originalImageHeight"));
        //center it
        $jq(theItem).css("margin-left", ((winWidth - $jq(theItem).outerWidth()) / 2)).css("margin-top", ((winHeight - $jq(theItem).outerHeight()) / 2));
    }
}

//image view mode function - full or fit
function ImageViewMode(theMode) {
    toolbar.data("imageViewMode", theMode); //store new mode
    FullScreenBackground(bgimg); //scale bg image
    //re-style button
    if (theMode == "full") {
        toolbar.html("<span class='lightgrey'>IMAGE VIEW MODE &rsaquo;</span> FULL");
    } else if (theMode == "fit") {
        toolbar.html("<span class='lightgrey'>IMAGE VIEW MODE &rsaquo;</span> FIT");
    } else {
        toolbar.html("<span class='lightgrey'>IMAGE VIEW MODE &rsaquo;</span> ORIGINAL");
    }
}

// INIT Sideways
function sidewaysInit(bgAutoColor, sbEffect) {    
  
    bg.data("bgAutoColor", bgAutoColor);
    bg.data("sbEffect", sbEffect);
    
  
    toolbar.data("imageViewMode", defaultViewMode); //default view mode
    ImageViewMode(toolbar.data("imageViewMode"));
    //cache vars
    var customScrollBox = $jq("#customScrollBox");
    var customScrollBox_container = $jq("#customScrollBox .container");
    var customScrollBox_content = $jq("#customScrollBox .content");
    var dragger_container = $jq("#dragger_container");
    var dragger = $jq("#dragger");

    CustomScroller();

    function CustomScroller() {
        outerMargin = 0;
        innerMargin = 20;
        customScrollBox.height($jq(window).height() - outerMargin);
        dragger_container.height($jq(window).height() - innerMargin);
        visibleHeight = $jq(window).height() - outerMargin;
        if (customScrollBox_container.height() > visibleHeight) { //custom scroll depends on content height
            dragger_container, dragger.css("display", "block");
            totalContent = customScrollBox_content.height();
            draggerContainerHeight = $jq(window).height() - innerMargin;
            animSpeed = 400; //animation speed
            easeType = "easeOutCirc"; //easing type
            bottomSpace = 1.05; //bottom scrolling space
            targY = 0;
            draggerHeight = dragger.height();
            dragger.draggable({
                axis: "y",
                containment: "parent",
                drag: function(event, ui) {
                    Scroll();
                },
                stop: function(event, ui) {
                    DraggerOut();
                }
            });

            //scrollbar click
            dragger_container.click(function(e) {
                var mouseCoord = (e.pageY - $jq(this).offset().top);
                var targetPos = mouseCoord + dragger.height();
                if (targetPos < draggerContainerHeight) {
                    dragger.css("top", mouseCoord);
                    Scroll();
                } else {
                    dragger.css("top", draggerContainerHeight - dragger.height());
                    Scroll();
                }
            });

            //mousewheel
            $jq(function($) {
                customScrollBox.bind("mousewheel", function(event, delta) {
                    vel = Math.abs(delta * 10);
                    dragger.css("top", dragger.position().top - (delta * vel));
                    Scroll();
                    if (dragger.position().top < 0) {
                        dragger.css("top", 0);
                        customScrollBox_container.stop();
                        Scroll();
                    }
                    if (dragger.position().top > draggerContainerHeight - dragger.height()) {
                        dragger.css("top", draggerContainerHeight - dragger.height());
                        customScrollBox_container.stop();
                        Scroll();
                    }
                    return false;
                });
            });

            function Scroll() {
                var scrollAmount = (totalContent - (visibleHeight / bottomSpace)) / (draggerContainerHeight - draggerHeight);
                var draggerY = dragger.position().top;
                targY = -draggerY * scrollAmount;
                var thePos = customScrollBox_container.position().top - targY;
                customScrollBox_container.stop().animate({
                    top: "-=" + thePos
                }, animSpeed, easeType); //with easing
            }

            //dragger hover
            dragger.mouseup(function() {
                DraggerOut();
            }).mousedown(function() {
                DraggerOver();
            });

            function DraggerOver() {
                dragger.css("background", "url(/sites/all/libraries/sideways/round_custom_scrollbar_bg_over.png)");
            }

            function DraggerOut() {
                dragger.css("background", "url(/sites/all/libraries/sideways/round_custom_scrollbar_bg.png)");
            }
        } else { //hide custom scrollbar if content is short
            dragger, dragger_container.css("display", "none");
        }
    }

    //resize browser window functions
    $jq(window).resize(function() {
        FullScreenBackground("#bgimg"); //scale bg image
        dragger.css("top", 0); //reset content scroll
        customScrollBox_container.css("top", 0);
        customScrollBox.unbind("mousewheel");
        CustomScroller();
    });
    
    LargeImageLoad(bgimg);    
}


function rgbToHex(r, g, b) {
    if (r > 255 || g > 255 || b > 255)
        throw "Invalid color component";
    return ((r << 16) | (g << 8) | b).toString(16);
}

function canvasRGBtoHex(img){
  canvas[0].width = img[0].width;
  canvas[0].height = img[0].height
  context.drawImage(img[0], 0, 0);
  // determina il colore di sfondo corrispondente al valore RGB estratto da un punto definito dell'immagine thumb
  // con l'augurio di azzeccare il punto migliore per la maggior parte delle immagini, considerato che il thumb puo non essere identico all'immagine
  // per ora x,y = 2px, img[0].height-2 px
  var p = context.getImageData(1, (img[0].height-1), 1, 1).data;
  var hex = "#" + ("000000" + rgbToHex(p[0], p[1], p[2])).slice(-6);
  return hex;
}

/******* EVENTS ******/

//loading bg image
bgimg.load(function() {    
    LargeImageLoad($jq(this));	
});

//slide in/out left pane
outer_container.hover(function() { //mouse over
    SlidePanels("open");
}, function() { //mouse out
    SlidePanels("close");
});

//Clicking on thumbnail changes the background image
outer_container_a.click(function(event) {  
    event.preventDefault();    
    var el = this;
    bgimg.css("display", "none");
    preloader.fadeIn("fast"); //show preloader
    //style clicked thumbnail
    outer_container_a.each(function() {
        $jq(this).children(".selected").css("display", "none");
    });
    $jq(this).children(".selected").css("display", "block");
    //get and store next image and selected thumb
    outer_container.data("selectedThumb", el);
    bg.data("nextImage", $jq(this).next().attr("href"));
    bg.data("newTitle", $jq(this).children("img").attr("title")); //get and store new image title attribute
    itemIndex = getIndex(el); //get clicked item index
    lastItemIndex = (outer_container_a.length) - 1; //get last item index
    bgimg.attr("src", "").attr("src", el); //switch image
    
    if (bg.data("bgAutoColor")) {
      // colore di sfondo definito in base all'immagine mostrata
      // utilizzo di canvas (HTML5)
      var img = $jq(this).children("img"); // usa il thumbnail come immagine di riferimento       
      var cssObj = {
	'cssText' : 'background: ' + canvasRGBtoHex(img) + ' !important', //http://hungred.com/how-to/jquery-javascript-css-important/
	'font-weight' : '',
	'color' : 'rgb(0,40,244)'
      }
      $jq("body").css(cssObj);
      
      //clear canvas importante per liberare risorse
      context.clearRect(0, 0, canvas[0].width, canvas[0].height);
    }
});

//clicking on large image loads the next one
bgimg.click(function(event) {
    //var el = $jq(this);    
    if (bg.data("nextImage")) { //if next image data is stored
        $jq(this).css("display", "none");
        preloader.fadeIn("fast"); //show preloader
        $jq(outer_container.data("selectedThumb")).children(".selected").css("display", "none"); //deselect thumb
        if (bg.data("lastImageReached") != "Y") {
            $jq(outer_container.data("selectedThumb")).next().children(".selected").css("display", "block"); //select new thumb
	    var img = $jq(outer_container.data("selectedThumb")).next().children("img");  // usa il thumb come img di riferimento  
        } else {
            outer_container_a.first().children(".selected").css("display", "block"); //select new thumb - first
	    var img = outer_container_a.first().children("img");  // usa il thumb come img di riferimento  
        }
        //store new selected thumb
        var selThumb = outer_container.data("selectedThumb");
        if (bg.data("lastImageReached") != "Y") {
            outer_container.data("selectedThumb", $jq(selThumb).next());
        } else {
            outer_container.data("selectedThumb", outer_container_a.first());
        }
        bg.data("newTitle", $jq(outer_container.data("selectedThumb")).children("img").attr("title")); //get and store new image title attribute
        if (bg.data("lastImageReached") != "Y") {
            itemIndex++;
        } else {
            itemIndex = 0;
        }
        $jq(this).attr("src", "").attr("src", bg.data("nextImage")); //switch image
	
	
	if (bg.data("bgAutoColor")) { 
	  // colore di sfondo definito in base all'immagine mostrata
	  // utilizzo di canvas (HTML5)	     
	  var cssObj = {
	    'cssText' : 'background: ' + canvasRGBtoHex(img) + ' !important', //http://hungred.com/how-to/jquery-javascript-css-important/
	    'font-weight' : '',
	    'color' : 'rgb(0,40,244)'
	  }
	  $jq("body").css(cssObj);
	  
	  //clear canvas importante per liberare risorse
	  context.clearRect(0, 0, canvas[0].width, canvas[0].height);
	}
    }
});

//toolbar (image view mode button) hover
toolbar.hover(function() { //mouse over
    $jq(this).stop().fadeTo("fast", 1);
}, function() { //mouse out
    $jq(this).stop().fadeTo("fast", 0.8);
});

toolbar.stop().fadeTo("fast", 0.8); //set its original state

//Clicking on toolbar changes the image view mode
toolbar.click(function(event) {
    if (toolbar.data("imageViewMode") == "full") {
        ImageViewMode("fit");
    } else if (toolbar.data("imageViewMode") == "fit") {
        ImageViewMode("original");
    } else if (toolbar.data("imageViewMode") == "original") {
        ImageViewMode("full");
    }
});


// Attivazione

//preload script images
var images = ["ajax-loader_dark.gif", "round_custom_scrollbar_bg_over.png"];
$jq.each(images, function(i) {
    images[i] = new Image();
    images[i].src = "/sites/all/libraries/sideways/" + this;    
});
